#include <bits/stdc++.h>
    using namespace std;
    
    int func(int a, int b)
    {
        if(b==0)
        return a;
        return func(b,a%b);
    }
    
    int main()
    {
        int t;
        int n,m,max=0;
        int pom;
        cin>>t;
        for(int j=0;j<t;j++)
        {
            cin>>n>>m;
                long long arr1[n];
                long long arr2[m];
            for(int i=0;i<n;i++)
                cin>>arr1[i];
            for(int i=0;i<m;i++)
                cin>>arr2[i];
            sort(&arr1[0],&arr1[n-1]);
            pom=arr1[0]-arr1[1];
            for(int i=2; i<n-1; i++)
            {
                pom=func(pom,arr1[i]-arr1[i-1]);
            }
            if(pom==1)
            {
                cout<<"0"<<endl;
            }
            else
            {
                for(int i=0;i<m;i++)
                {
                    if((arr1[0]-arr2[i])%pom==0)
                    {
                        cout<<"0"<<endl;
                        break;
                    }
                    cout<<"1"<<endl;
                }
                    
            }
            cout<<pom;
        }
    }
    //IZMENJTI INTIGERE